/**
 * jQuery-csv (jQuery Plugin)
 * version: 0.71 (2012-11-19)
 *
 * This document is licensed as free software under the terms of the
 * MIT License: http://www.opensource.org/licenses/mit-license.php
 *
 * Acknowledgements:
 * The original design and influence to implement this library as a jquery
 * plugin is influenced by jquery-json (http://code.google.com/p/jquery-json/).
 * If you're looking to use native JSON.Stringify but want additional backwards
 * compatibility for browsers that don't support it, I highly recommend you
 * check it out.
 *
 * A special thanks goes out to rwk@acm.org for providing a lot of valuable
 * feedback to the project including the core for the new FSM
 * (Finite State Machine) parsers. If you're looking for a stable TSV parser
 * be sure to take a look at jquery-tsv (http://code.google.com/p/jquery-tsv/).

 * For legal purposes I'll include the "NO WARRANTY EXPRESSED OR IMPLIED.
 * USE AT YOUR OWN RISK.". Which, in 'layman's terms' means, by using this
 * library you are accepting responsibility if it breaks your code.
 *
 * Legal jargon aside, I will do my best to provide a useful and stable core
 * that can effectively be built on.
 *
 * Copyrighted 2012 by Evan Plaice.
 */
 RegExp.escape=function(n){return n.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")},function(n){"use strict";n.csv={defaults:{separator:";",delimiter:'"',headers:!0},hooks:{castToScalar:function(n){var r=/\./,i;return isNaN(n)?n:r.test(n)?parseFloat(n):(i=parseInt(n),isNaN(i)?null:i)}},parsers:{parse:function(n,t){function h(){if(i=0,r="",t.start&&t.state.rowNum<t.start){u=[],t.state.rowNum++,t.state.colNum=1;return}if(t.onParseEntry===undefined)c.push(u);else{var n=t.onParseEntry(u,t.state);n!==!1&&c.push(n)}u=[],t.end&&t.state.rowNum>=t.end&&(a=!0),t.state.rowNum++,t.state.colNum=1}function f(){if(t.onParseValue===undefined)u.push(r);else{var n=t.onParseValue(r,t.state);n!==!1&&u.push(n)}r="",i=0,t.state.colNum++}var s=t.separator,e=t.delimiter;t.state.rowNum||(t.state.rowNum=1),t.state.colNum||(t.state.colNum=1);var c=[],u=[],i=0,r="",a=!1;var v=RegExp.escape(s),y=RegExp.escape(e),l=/(D|S|\n|\r|[^DS\r\n]+)/,o=l.source;return o=o.replace(/S/g,v),o=o.replace(/D/g,y),l=RegExp(o,"gm"),n.replace(l,function(n){if(!a)switch(i){case 0:if(n===s){r+="",f();break}if(n===e){i=1;break}if(n==="\n"){f(),h();break}if(/^\r$/.test(n))break;r+=n,i=3;break;case 1:if(n===e){i=2;break}r+=n,i=1;break;case 2:if(n===e){r+=n,i=1;break}if(n===s){f();break}if(n==="\n"){f(),h();break}if(/^\r$/.test(n))break;throw new Error("CSVDataError: Illegal State [Row:"+t.state.rowNum+"][Col:"+t.state.colNum+"]");case 3:if(n===s){f();break}if(n==="\n"){f(),h();break}if(/^\r$/.test(n))break;if(n===e)throw new Error("CSVDataError: Illegal Quote [Row:"+t.state.rowNum+"][Col:"+t.state.colNum+"]");throw new Error("CSVDataError: Illegal Data [Row:"+t.state.rowNum+"][Col:"+t.state.colNum+"]");default:throw new Error("CSVDataError: Unknown State [Row:"+t.state.rowNum+"][Col:"+t.state.colNum+"]");}}),u.length!==0&&(f(),h()),c},splitLines:function(n,t){function o(){if(r=0,t.start&&t.state.rowNum<t.start){i="",t.state.rowNum++;return}if(t.onParseEntry===undefined)s.push(i);else{var n=t.onParseEntry(i,t.state);n!==!1&&s.push(n)}i="",t.end&&t.state.rowNum>=t.end&&(c=!0),t.state.rowNum++}var e=t.separator,u=t.delimiter;t.state.rowNum||(t.state.rowNum=1);var s=[],r=0,i="",c=!1;var l=RegExp.escape(e),a=RegExp.escape(u),h=/(D|S|\n|\r|[^DS\r\n]+)/,f=h.source;return f=f.replace(/S/g,l),f=f.replace(/D/g,a),h=RegExp(f,"gm"),n.replace(h,function(n){if(!c)switch(r){case 0:if(n===e){i+=n,r=0;break}if(n===u){i+=n,r=1;break}if(n==="\n"){o();break}if(/^\r$/.test(n))break;i+=n,r=3;break;case 1:if(n===u){i+=n,r=2;break}i+=n,r=1;break;case 2:var f=i.substr(i.length-1);if(n===u&&f===u){i+=n,r=1;break}if(n===e){i+=n,r=0;break}if(n==="\n"){o();break}if(n==="\r")break;throw new Error("CSVDataError: Illegal state [Row:"+t.state.rowNum+"]");case 3:if(n===e){i+=n,r=0;break}if(n==="\n"){o();break}if(n==="\r")break;if(n===u)throw new Error("CSVDataError: Illegal quote [Row:"+t.state.rowNum+"]");throw new Error("CSVDataError: Illegal state [Row:"+t.state.rowNum+"]");default:throw new Error("CSVDataError: Unknown state [Row:"+t.state.rowNum+"]");}}),i!==""&&o(),s},parseEntry:function(n,t){function o(){if(t.onParseValue===undefined)s.push(r);else{var n=t.onParseValue(r,t.state);n!==!1&&s.push(n)}r="",i=0,t.state.colNum++}var e=t.separator,u=t.delimiter;t.state.rowNum||(t.state.rowNum=1),t.state.colNum||(t.state.colNum=1);var s=[],i=0,r="";if(!t.match){var h=RegExp.escape(e),c=RegExp.escape(u),l=/(D|S|\n|\r|[^DS\r\n]+)/,f=l.source;f=f.replace(/S/g,h),f=f.replace(/D/g,c),t.match=RegExp(f,"gm")}return n.replace(t.match,function(n){switch(i){case 0:if(n===e){r+="",o();break}if(n===u){i=1;break}if(n==="\n"||n==="\r")break;r+=n,i=3;break;case 1:if(n===u){i=2;break}r+=n,i=1;break;case 2:if(n===u){r+=n,i=1;break}if(n===e){o();break}if(n==="\n"||n==="\r")break;throw new Error("CSVDataError: Illegal State [Row:"+t.state.rowNum+"][Col:"+t.state.colNum+"]");case 3:if(n===e){o();break}if(n==="\n"||n==="\r")break;if(n===u)throw new Error("CSVDataError: Illegal Quote [Row:"+t.state.rowNum+"][Col:"+t.state.colNum+"]");throw new Error("CSVDataError: Illegal Data [Row:"+t.state.rowNum+"][Col:"+t.state.colNum+"]");default:throw new Error("CSVDataError: Unknown State [Row:"+t.state.rowNum+"][Col:"+t.state.colNum+"]");}}),o(),s}},toArray:function(t,i,r){var i=i!==undefined?i:{},u={};u.callback=r!==undefined&&typeof r=="function"?r:!1,u.separator="separator"in i?i.separator:n.csv.defaults.separator,u.delimiter="delimiter"in i?i.delimiter:n.csv.defaults.delimiter;var e=i.state!==undefined?i.state:{},i={delimiter:u.delimiter,separator:u.separator,onParseEntry:i.onParseEntry,onParseValue:i.onParseValue,state:e},f=n.csv.parsers.parseEntry(t,i);if(u.callback)u.callback("",f);else return f},toArrays:function(t,i,r){var i=i!==undefined?i:{},u={},f;if(u.callback=r!==undefined&&typeof r=="function"?r:!1,u.separator="separator"in i?i.separator:n.csv.defaults.separator,u.delimiter="delimiter"in i?i.delimiter:n.csv.defaults.delimiter,f=[],i={delimiter:u.delimiter,separator:u.separator,onParseEntry:i.onParseEntry,onParseValue:i.onParseValue,start:i.start,end:i.end,state:{rowNum:1,colNum:1}},f=n.csv.parsers.parse(t,i),u.callback)u.callback("",f);else return f},toObjects:function(t,i,r){var i=i!==undefined?i:{},u={},f,l,a,s,h;u.callback=r!==undefined&&typeof r=="function"?r:!1,u.separator="separator"in i?i.separator:n.csv.defaults.separator,u.delimiter="delimiter"in i?i.delimiter:n.csv.defaults.delimiter,u.headers="headers"in i?i.headers:n.csv.defaults.headers,i.start="start"in i?i.start:1,u.headers&&i.start++,i.end&&u.headers&&i.end++;var c=[],e=[],i={delimiter:u.delimiter,separator:u.separator,onParseEntry:i.onParseEntry,onParseValue:i.onParseValue,start:i.start,end:i.end,state:{rowNum:1,colNum:1},match:!1},v={delimiter:u.delimiter,separator:u.separator,start:1,end:1,state:{rowNum:1,colNum:1}},y=n.csv.parsers.splitLines(t,v),o=n.csv.toArray(y[0],i),c=n.csv.parsers.splitLines(t,i);for(i.state.colNum=1,i.state.rowNum=o?2:1,f=0,l=c.length;f<l;f++){a=n.csv.toArray(c[f],i),s={};for(h in o)s[o[h]]=a[h];e.push(s),i.state.rowNum++}if(u.callback)u.callback("",e);else return e},fromArrays:function(t,r,u){var r=r!==undefined?r:{},f={},e;if(f.callback=u!==undefined&&typeof u=="function"?u:!1,f.separator="separator"in r?r.separator:n.csv.defaults.separator,f.delimiter="delimiter"in r?r.delimiter:n.csv.defaults.delimiter,f.escaper="escaper"in r?r.escaper:n.csv.defaults.escaper,f.experimental="experimental"in r?r.experimental:!1,!f.experimental)throw new Error("not implemented");e=[];for(i in t)e.push(t[i]);if(f.callback)f.callback("",e);else return e},fromObjects2CSV:function(t,r,u){var r=r!==undefined?r:{},f={},e;if(f.callback=u!==undefined&&typeof u=="function"?u:!1,f.separator="separator"in r?r.separator:n.csv.defaults.separator,f.delimiter="delimiter"in r?r.delimiter:n.csv.defaults.delimiter,f.experimental="experimental"in r?r.experimental:!1,!f.experimental)throw new Error("not implemented");e=[];for(i in t)e.push(arrays[i]);if(f.callback)f.callback("",e);else return e}},n.csvEntry2Array=n.csv.toArray,n.csv2Array=n.csv.toArrays,n.csv2Dictionary=n.csv.toObjects}(jQuery);